﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class GameRiver : GameBase {

	private float[] _PaddleForces;
	private float _EndGoal;
	private float _GameTimer;

	public GameObject[] _Rivers;
	public Transform[] _Boats;
	public float _GameTime;
	public Text _UITimer;

	// Use this for initialization
	void Start () {
		bool[] _setPlayer = new bool[4];
		int index;
		Vector3 scale = Vector3.one;
		/* Randomly flip */
		if (Random.Range (0, 2) == 0) {
			scale.y = -1.0f;
		}
		for (int i = 0; i < _Rivers.Length; i++) {
			_Rivers [i].transform.localScale = scale;
			_Rivers [i].SetActive (i == (_gameManager.Stage () - 1));
		}
		_EndGoal = Camera.main.orthographicSize * Camera.main.aspect;
		_GameTimer = _GameTime;
		foreach (Transform boat in _Boats) {
			// Set left
			do
			{
				index = Random.Range(0, _setPlayer.Length);
			}
			while(_setPlayer[index]);
			_setPlayer [index] = true;
			boat.GetComponent<Boat> ()._players [0] = index + 1;
			// Set right
			do
			{
				index = Random.Range(0, _setPlayer.Length);
			}
			while(_setPlayer[index]);
			_setPlayer [index] = true;
			boat.GetComponent<Boat> ()._players [1] = index + 1;
		}
	}
	
	// Update is called once per frame
	void Update () {
		_GameTimer -= Time.deltaTime;
		_UITimer.text = _GameTimer.ToString ("#00.00");
		if (_GameTimer < 15.0f) {
			_UITimer.color = Color.red;
		}
		if ((_GameTimer <= 0.0f) || 
			((_Boats[0].GetComponent<Boat>().Banked() && _Boats[1].GetComponent<Boat>().Banked()))) {
			_gameManager.OnEndOfGame (false);
		}
		foreach (Transform boat in _Boats) {
			if (boat.position.x > _EndGoal) {
				_gameManager.OnEndOfGame (true);
			}
		}
	}
}
