﻿using UnityEngine;
using System.Collections;

public class MexicanPenguin : MonoBehaviour {

	private SpriteRenderer _spriteRenderer;
	private enum States
	{
		idle,
		crouch,
		jump
	}
	private States _state;
	private float _timer;

	public Sprite[] _sprites;
	public string _button;
	public int _playerNumber;

	// Use this for initialization
	void Start () {
		_spriteRenderer = GetComponent<SpriteRenderer> ();
		_spriteRenderer.sprite = _sprites [0];
		_state = States.idle;
		_timer = 0.0f;
	}
	
	// Update is called once per frame
	void Update () {
		switch (_state) {
		case States.idle:
			if (Input.GetAxis (_button + _playerNumber.ToString()) != 0.0f) {
				Crouch ();
			}
			break;
		case States.crouch:
			if (Input.GetAxis (_button + _playerNumber.ToString()) == 0.0f) {
				Jump ();
			}
			break;
		case States.jump:
			_timer += Time.deltaTime;
			if (_timer > 0.5f) {
				_timer = 0.0f;
				_state = States.idle;
				_spriteRenderer.sprite = _sprites [0];
			}
			break;
		}
	}

	public void Crouch()
	{
		_state = States.crouch;
		_spriteRenderer.sprite = _sprites [1];
	}

	public void Jump()
	{
		_state = States.jump;
		_spriteRenderer.sprite = _sprites [2];
		_timer = 0.0f;
	}

	public bool Jumping()
	{
		return _state == States.jump;
	}
}
