﻿using UnityEngine;
using System.Collections;

public class SpriteCycle : MonoBehaviour {

	private SpriteRenderer _sprite;
	private int _currSprite;
	private float _currDelay;

	public Sprite[] _sprites;
	public float[] _delays;

	// Use this for initialization
	void Start () {
		_sprite = GetComponent<SpriteRenderer> ();
		_currSprite = 0;
		_sprite.sprite = _sprites [_currSprite];
		_currDelay = 0.0f;
	}
	
	// Update is called once per frame
	void Update () {
		_currDelay += Time.deltaTime;
		if (_currDelay >= _delays [_currSprite]) {
			// Next
			_currSprite = (_currSprite + 1) % _sprites.Length;
			_sprite.sprite = _sprites [_currSprite];
			_currDelay = 0.0f;
		}
	}
}
