﻿using UnityEngine;
using System.Collections;

public class SpriteFader : MonoBehaviour {

	private SpriteRenderer _sprite;
	private Color _colour;
	private int state;
	private float _timer;

	public float _preFade;
	public float _fadeIn;
	public float _delay;
	public float _fadeOut;
	public SpriteFader _FollowOn;

	// Use this for initialization
	void Start () {
		_sprite = GetComponent<SpriteRenderer> ();
		_colour = Color.white;
		_colour.a = 0.0f;
		_sprite.color = _colour;
		state = 0;
	}
	
	// Update is called once per frame
	void Update () {
		switch (state) {
		case 0:
			_timer += Time.deltaTime;
			if (_timer >= _preFade) {
				state = 1;
			}
			break;
		case 1:
			_colour.a += Time.deltaTime / _fadeIn;
			_sprite.color = _colour;
			if (_colour.a >= 1.0f) {
				state = 2;
				_timer = _delay;
				if (_timer < 0.0f) {
					// Don't fade out
					state = 4;
				}
			}
			break;
		case 2:
			_timer -= Time.deltaTime;
			if (_timer <= 0.0f) {
				state = 3;
			}
			break;
		case 3:
			_colour.a -= Time.deltaTime / _fadeOut;
			_sprite.color = _colour;
			if (_colour.a <= 0.0f) {
				state = 4;
				if (_FollowOn != null) {
					_FollowOn.enabled = true;
				}
				GameManager.Instance.OnFadeComplete ();
			}
			break;
		default:
			break;
		}
	}
}
